## net.sf.saxon.style
Class XSLStylesheet

    java.lang.Object
      net.sf.saxon.tree.linked.NodeImpl
          net.sf.saxon.tree.linked.ElementImpl
              net.sf.saxon.style.StyleElement
                  net.sf.saxon.style.XSLStylesheet

All Implemented Interfaces:
  Serializable, Source, SourceLocator, LocationProvider, SaxonLocator, PullEvent, Container, FingerprintedNode, Item, MutableNodeInfo, NamespaceResolver, NodeInfo, ValueRepresentation, InstructionInfo, SiblingCountingNode, Locator

    public class XSLStylesheet

extends StyleElement

An xsl:stylesheet or xsl:transform element in the stylesheet.
Note this element represents a stylesheet module, not necessarily the whole stylesheet. However, much of the functionality (and the fields) are relevant only to the top-level module.

See Also:
  Serialized Form

Field Summary
`static int` `ANNOTATION_PRESERVE`
`static int` `ANNOTATION_STRIP`
`static int` `ANNOTATION_UNSPECIFIED`

Fields inherited from class net.sf.saxon.style.StyleElement
`ACTION_COMPILE, ACTION_FIXUP, ACTION_OPTIMIZE, ACTION_PROCESS_ATTRIBUTES, ACTION_TYPECHECK, ACTION_VALIDATE, actionsCompleted, defaultCollationName, defaultXPathNamespace, extensionNamespaces, REPORT_ALWAYS, REPORT_IF_INSTANTIATED, REPORT_UNLESS_FALLBACK_AVAILABLE, REPORT_UNLESS_FORWARDS_COMPATIBLE, reportingCircumstances, staticContext, validationError, version`

Fields inherited from class net.sf.saxon.tree.linked.NodeImpl
`NODE_LETTER`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Constructor Summary
`XSLStylesheet()`

Method Summary
`protected void` `addChild(NodeImpl node, int index)` Add a child node to this node.
`void` `compact(int size)` Compact the space used by this node
`Expression` `compile(Executable exec, Declaration decl)` Dummy compile() method to satisfy the interface
`protected AxisIterator` `enumerateChildren(NodeTest test)` Get an enumeration of the children of this node
`StructuredQName` `getDefaultMode()` Get the default mode (XSLT 3.0 feature)
`int` `getDefaultValidation()` Get the value of the default validation attribute
`PreparedStylesheet` `getExecutable()` Get the run-time Executable object
`NodeInfo` `getFirstChild()` Get the first child node of the element
`int` `getInputTypeAnnotationsAttribute()` Get the value of the input-type-annotations attribute, for this module alone.
`KeyManager` `getKeyManager()` Get the KeyManager which handles key definitions
`NodeInfo` `getLastChild()` Get the last child node of the element
`LocationMap` `getLocationMap()` Get the locationMap object
`protected NodeImpl` `getNthChild(int n)` Get the nth child node of the element (numbering from 0)
`int` `getNumberOfChildren()` Determine how many children the node has
`PreparedStylesheet` `getPreparedStylesheet()` Get the owning PreparedStylesheet object.
`PrincipalStylesheetModule` `getPrincipalStylesheetModule()` Get the principal stylesheet module
`protected int` `getRawSequenceNumber()`
`RuleManager` `getRuleManager()` Get the RuleManager which handles template rules
`protected long` `getSequenceNumber()` Get the node sequence number (in document order).
`String` `getStringValue()` Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.
`CharSequence` `getStringValueCS()` Get the value of the item as a CharSequence.
`boolean` `hasChildNodes()` Determine if the node has any children.
`void` `insertChildren(NodeInfo[] source, boolean atStart, boolean inherit)` Insert a sequence of nodes as children of this node.
`protected void` `insertChildrenAt(NodeInfo[] source, int index, boolean inherit)` Insert children before or after a given existing child
`protected boolean` `mayContainParam(String attName)` Determine whether this type of element is allowed to contain an xsl:param element
`void` `prepareAttributes()` Prepare the attributes on the stylesheet element
`void` `processAllAttributes()` Process the attributes of every node in the stylesheet
`protected void` `removeChild(NodeImpl child)` Remove a given child
`protected void` `replaceChildrenAt(NodeInfo[] source, int index, boolean inherit)` Replace child at a given index by new children
`protected void` `setChildren(Object children)` Set the children of this node
`void` `setPrincipalStylesheetModule(PrincipalStylesheetModule module)`
`protected void` `setRawSequenceNumber(int seq)`
`void` `validate(Declaration decl)` Validate this element

Methods inherited from class net.sf.saxon.style.StyleElement

`allocateLocationId, allocatePatternSlots, allocateSlots, bindVariable, checkEmpty, checkSortComesFirst, checkTopLevel, checkUnknownAttribute, compileError, compileError, compileError, compileError, compileSequenceConstructor, compileWarning, compileWarning, definesExcludedNamespace, definesExtensionElement, fallbackProcessing, fixupReferences, forwardsCompatibleModeIsEnabled, getAttributeSets, getAttributeValue, getColumnNumber, getCommonChildItemType, getConstructType, getContainerGranularity, getContainingSlotManager, getContainingStylesheet, getDefaultCollationName, getDefaultXPathNamespace, getEffectiveVersion, getHostLanguage, getLastChildInstruction, getLineNumber, getLocationProvider, getNamespaceResolver, getObjectName, getProcessorVersion, getProperties, getProperty, getReturnedItemType, getSchemaType, getStaticContext, getSystemId, getTypeAnnotation, getWithParamInstructions, index, isActionCompleted, isDeclaration, isExcludedNamespace, isExplaining, isExtensionNamespace, isInstruction, isPermittedChild, issueWarning, issueWarning, isTopLevel, isXslt30Processor, makeAttributeValueTemplate, makeExpression, makeExpressionVisitor, makeNamespaceContext, makePattern, makeQName, makeSequenceType, makeSortKeys, makeTraceInstruction, markTailCalls, mayContainFallback, mayContainSequenceConstructor, postValidate, processAttributes, processDefaultCollationAttribute, processDefaultXPathNamespaceAttribute, processExcludedNamespaces, processExtensionElementAttribute, processStandardAttributes, processVersionAttribute, reportAbsence, seesAvuncularVariables, setActionCompleted, setObjectName, setValidationError, substituteFor, typeCheck, typeCheck, undeclaredNamespaceError, validateChildren, validateSubtree, xPath10ModeIsEnabled`

Methods inherited from class net.sf.saxon.tree.linked.ElementImpl

`addAttribute, addNamespace, copy, delete, fixupInsertedNamespaces, generateId, getAttributeList, getAttributeValue, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDocumentRoot, getInScopeNamespaceCodes, getLineNumber, getNameCode, getNamespaceList, getNodeKind, getPrefixForURI, getRoot, getSystemId, getTypeAnnotation, getURICodeForPrefix, getURICodeForPrefixCode, getURIForPrefix, gsetAttributeCollection, initialise, isId, isNilled, iteratePrefixes, removeAttribute, removeTypeAnnotation, rename, replaceStringValue, setAttributeList, setLineAndColumn, setLocation, setNameCode, setNamespaceDeclarations, setNamespaceList, setSystemId, setTypeAnnotation`

Methods inherited from class net.sf.saxon.tree.linked.NodeImpl

`atomize, compareOrder, equals, getConfiguration, getDisplayName, getDocumentNumber, getFingerprint, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getParent, getPhysicalRoot, getPrefix, getPreviousInDocument, getPreviousSibling, getPublicId, getRawParent, getSiblingPosition, getTypedValue, getURI, insertSiblings, isDeleted, isIdref, isSameNodeInfo, iterateAxis, iterateAxis, newBuilder, replace, setRawParent, setSiblingPosition`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.trace.InstructionInfo
`getLineNumber, getSystemId`

Methods inherited from interface org.xml.sax.Locator
`getColumnNumber, getPublicId`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getPublicId`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`hashCode`

Field Detail

### ANNOTATION_UNSPECIFIED

    public static final int ANNOTATION_UNSPECIFIED

See Also:
  Constant Field Values

### ANNOTATION_STRIP

    public static final int ANNOTATION_STRIP

See Also:
  Constant Field Values

### ANNOTATION_PRESERVE

    public static final int ANNOTATION_PRESERVE

See Also:
  Constant Field Values

Constructor Detail

### XSLStylesheet

    public XSLStylesheet()

Method Detail

### getPreparedStylesheet

    public PreparedStylesheet getPreparedStylesheet()

  Get the owning PreparedStylesheet object.

  Overrides:
    `getPreparedStylesheet` in class `StyleElement`
  Returns:
    the owning PreparedStylesheet object. Exceptionally returns null during early construction.

### setPrincipalStylesheetModule

    public void setPrincipalStylesheetModule(PrincipalStylesheetModule module)

### getPrincipalStylesheetModule

    public PrincipalStylesheetModule getPrincipalStylesheetModule()

  Description copied from class: `StyleElement`
  Get the principal stylesheet module

  Overrides:
    `getPrincipalStylesheetModule` in class `StyleElement`
  Returns:
    the principal stylesheet module

### getExecutable

    public PreparedStylesheet getExecutable()

  Get the run-time Executable object

  Specified by:
    `getExecutable` in interface `Container`
  Overrides:
    `getExecutable` in class `StyleElement`
  Returns:
    the executable

### mayContainParam

    protected boolean mayContainParam(String attName)

  Description copied from class: `StyleElement`
  Determine whether this type of element is allowed to contain an xsl:param element

  Overrides:
    `mayContainParam` in class `StyleElement`
  Parameters:
    `attName` - if null, the method tests whether an xsl:param child is allowed. If non-null, it tests whether an xsl:param child with the given attribute name is allowed
  Returns:
    true if this element is allowed to contain an xsl:param

### getLocationMap

    public LocationMap getLocationMap()

  Get the locationMap object

  Returns:
    the LocationMap

### getRuleManager

    public RuleManager getRuleManager()

  Get the RuleManager which handles template rules

  Returns:
    the template rule manager

### getDefaultMode

    public StructuredQName getDefaultMode()

  Get the default mode (XSLT 3.0 feature)

  Returns:
    the default mode name for this stylesheet module. A return value of null indicates either that no default mode was specified, or that default-mode="#unnamed" was specified.

### getKeyManager

    public KeyManager getKeyManager()

  Get the KeyManager which handles key definitions

  Returns:
    the key manager

### prepareAttributes

    public void prepareAttributes()
                           throws XPathException

  Prepare the attributes on the stylesheet element

  Specified by:
    `prepareAttributes` in class `StyleElement`
  Throws:
    `XPathException`

### getDefaultValidation

    public int getDefaultValidation()

  Get the value of the default validation attribute

  Returns:
    the value of the default-validation attribute, as a constant such as `Validation.STRIP`

### getInputTypeAnnotationsAttribute

    public int getInputTypeAnnotationsAttribute()
                                         throws XPathException

  Get the value of the input-type-annotations attribute, for this module alone. The value is an or-ed combination of the two bits `ANNOTATION_STRIP` and `ANNOTATION_PRESERVE`

  Returns:
    the value if the input-type-annotations attribute in this stylesheet module
  Throws:
    `XPathException`

### validate

    public void validate(Declaration decl)
                  throws XPathException

  Validate this element

  Overrides:
    `validate` in class `StyleElement`
  Parameters:
    `decl` -
  Throws:
    `XPathException`

### processAllAttributes

    public void processAllAttributes()
                              throws XPathException

  Process the attributes of every node in the stylesheet

  Overrides:
    `processAllAttributes` in class `StyleElement`
  Throws:
    `XPathException` - in the event of a static error being detected

### compile

    public Expression compile(Executable exec,
                              Declaration decl)

  Dummy compile() method to satisfy the interface

  Specified by:
    `compile` in class `StyleElement`
  Parameters:
    `exec` - the Executable
    `decl` - the containing top-level declaration, for example xsl:function or xsl:template
  Returns:
    either a ComputedExpression, or null. The value null is returned when compiling an instruction that returns a no-op, or when compiling a top-level object such as an xsl:template that compiles into something other than an instruction.

### getSequenceNumber

    protected final long getSequenceNumber()

  Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. In the current implementation, parent nodes (elements and document nodes) have a zero least-significant word, while namespaces, attributes, text nodes, comments, and PIs have the top word the same as their owner and the bottom half reflecting their relative position. For nodes added by XQUery Update, the sequence number is -1L

  Overrides:
    `getSequenceNumber` in class `NodeImpl`
  Returns:
    the sequence number if there is one, or -1L otherwise.

### getRawSequenceNumber

    protected final int getRawSequenceNumber()

### setRawSequenceNumber

    protected final void setRawSequenceNumber(int seq)

### setChildren

    protected final void setChildren(Object children)

  Set the children of this node

  Parameters:
    `children` - null if there are no children, a single NodeInfo if there is one child, an array of NodeInfo if there are multiple children

### hasChildNodes

    public final boolean hasChildNodes()

  Determine if the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Overrides:
    `hasChildNodes` in class `NodeImpl`
  Returns:
    `true` if the node has any children, `false` if the node has no children.

### getNumberOfChildren

    public final int getNumberOfChildren()

  Determine how many children the node has

  Returns:
    the number of children of this parent node

### enumerateChildren

    protected final AxisIterator enumerateChildren(NodeTest test)

  Get an enumeration of the children of this node

  Parameters:
    `test` - A NodeTest to be satisfied by the child nodes, or null if all child node are to be returned
  Returns:
    an iterator over the children of this node

### getFirstChild

    public final NodeInfo getFirstChild()

  Get the first child node of the element

  Overrides:
    `getFirstChild` in class `NodeImpl`
  Returns:
    the first child node of the required type, or null if there are no children

### getLastChild

    public final NodeInfo getLastChild()

  Get the last child node of the element

  Overrides:
    `getLastChild` in class `NodeImpl`
  Returns:
    the last child of the element, or null if there are no children

### getNthChild

    protected final NodeImpl getNthChild(int n)

  Get the nth child node of the element (numbering from 0)

  Parameters:
    `n` - identifies the required child
  Returns:
    the last child of the element, or null if there is no n'th child

### removeChild

    protected void removeChild(NodeImpl child)

  Remove a given child

  Parameters:
    `child` - the child to be removed

### getStringValue

    public String getStringValue()

  Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.

  Returns:
    the accumulated character content of the element, including descendant elements.
  See Also:
    `Item.getStringValueCS()`

### getStringValueCS

    public CharSequence getStringValueCS()

  Description copied from class: `NodeImpl`
  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Overrides:
    `getStringValueCS` in class `NodeImpl`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### addChild

    protected void addChild(NodeImpl node,
                            int index)

  Add a child node to this node. For system use only. Note: normalizing adjacent text nodes is the responsibility of the caller.

  Parameters:
    `node` - the node to be added as a child of this node. This must be an instance of `NodeImpl`. It will be modified as a result of this call (by setting its parent property and sibling position)
    `index` - the position where the child is to be added

### insertChildren

    public void insertChildren(NodeInfo[] source,
                               boolean atStart,
                               boolean inherit)

  Insert a sequence of nodes as children of this node.

  This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

  The supplied nodes will form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

  Specified by:
    `insertChildren` in interface `MutableNodeInfo`
  Overrides:
    `insertChildren` in class `NodeImpl`
  Parameters:
    `source` - the nodes to be inserted. The implementation determines what implementation classes of node it will accept; this implementation will accept text, comment, and processing instruction nodes belonging to any implementation, but elements must be instances of `ElementImpl`. The supplied nodes will be modified in situ, for example to change their parent property and to add namespace bindings, if they are instances of `ElementImpl`; otherwise they will be copied. If the nodes are copied, then on return the supplied source array will contain the copy rather than the original.
    `atStart` - true if the new nodes are to be inserted before existing children; false if they are to be inserted after existing children
    `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
  Throws:
    `IllegalArgumentException` - if the supplied nodes use a node implementation that this implementation does not accept.

### insertChildrenAt

    protected void insertChildrenAt(NodeInfo[] source,
                                    int index,
                                    boolean inherit)

  Insert children before or after a given existing child

  Parameters:
    `source` - the children to be inserted. We allow any kind of text, comment, or processing instruction node, but element nodes must be instances of this NodeInfo implementation.
    `index` - the position before which they are to be inserted: 0 indicates insertion before the first child, 1 insertion before the second child, and so on.
    `inherit` - true if the inserted nodes are to inherit the namespaces that are in-scope for their new parent; false if such namespaces should be undeclared on the children

### replaceChildrenAt

    protected void replaceChildrenAt(NodeInfo[] source,
                                     int index,
                                     boolean inherit)

  Replace child at a given index by new children

  Parameters:
    `source` - the children to be inserted
    `index` - the position at which they are to be inserted: 0 indicates replacement of the first child, replacement of the second child, and so on. The effect is undefined if index is out of range
    `inherit` - set to true if the new child elements are to inherit the in-scope namespaces of their new parent
  Throws:
    `IllegalArgumentException` - if any of the replacement nodes is not an element, text, comment, or processing instruction node

### compact

    public void compact(int size)

  Compact the space used by this node

  Parameters:
    `size` - the number of actual children

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.